﻿using System;
using System.Collections.Generic;

namespace GradeBook
{
    class Program
    {
        static void Main(string[] args)
        {

            var book = new DiskBook("Jason's Grade Book");
            book.GradeAdded += OnGradeAdded;

            string input;

            input = EnterGrades(book);

            var stats = book.GetStatistics();

            Console.WriteLine($"The lowest grade is {stats.lowGrade}");
            Console.WriteLine($"The highesst grade is {stats.highGrade}");
            Console.WriteLine($"The average grade is {stats.Average:N1}");
        }

        private static string EnterGrades(Book book)
        {
            string input;
            while (true)
            {
                Console.WriteLine("Give input: ");
                input = Console.ReadLine();
                if (input == "Q" || input == "q")
                {
                    Console.WriteLine("Receiving termination signal; Termiate program");
                    break;
                }
                else
                {
                    try
                    {
                        Console.WriteLine($"Received: {input}");
                        book.AddGrade(Convert.ToDouble(input));
                        // book.AddGrade('A');
                    }
                    catch (ArgumentException ex)
                    {
                        Console.WriteLine(ex.Message);
                    }
                    catch (FormatException ex)
                    {
                        Console.WriteLine(ex.Message);
                    }
                    finally
                    {
                        // Will always run for all catch scenario
                        Console.WriteLine("Always Done");
                    }
                }
            }

            return input;
        }

        static void OnGradeAdded(object sender, EventArgs e)
        {
            // Main is static, so it can only call static methods, hence return type is static
            Console.WriteLine("A line has added");
        }
    }
}
